# file      : build/cxx/intel/cxx-o.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; http://www.gnu.org/licenses/gpl.txt

$(call include-once,$(bld_root)/c/cpp-options.make,$(out_root))
$(call include,$(bld_root)/cxx/intel/configuration.make)

$(out_root)/%.o: cxx := $(cxx_intel)
$(out_root)/%.o: cxx_options := $(cxx_intel_optimization_options) $(cxx_intel_debugging_options)

#@@ wrong prefix
#
define expand-cpp-options-impl
$(if $1,$(shell cat $1))
endef

define expand-cpp-options
$(call expand-cpp-options-impl,$(filter %.cpp-options,$1))
endef

$(out_root)/%.o: $(out_root)/%$(cxx_s_suffix) | $$(dir $$@).
	$(call message,c++ $<,$(cxx) $(cpp_options) $(call expand-cpp-options,$^) \
$(cxx_options) $(cxx_pic_options) -c -MD -MF $@.d -o $@ $<)


ifneq ($(out_root),$(src_root))

$(out_root)/%.o: $(src_root)/%$(cxx_s_suffix) | $$(dir $$@).
	$(call message,c++ $<,$(cxx) $(cpp_options) $(call expand-cpp-options,$^) \
$(cxx_options) $(cxx_pic_options) -c -MD -MF $@.d -o $@ $<)

endif


.PHONY: $(out_root)/%.o.clean

$(out_root)/%.o.clean:
	$(call message,rm $(basename $@),rm -f $(basename $@) $(basename $@).d)

# These rules are used to handle removed include files.
#
#@@ maybe factor them out as common?
#
/%.h:: ;
/%$(cxx_h_suffix):: ;
/%$(cxx_t_suffix):: ;
/%$(cxx_i_suffix):: ;
